<?php
  //$Id: scs.pages.inc,v 1.1.2.1.2.2 2010/06/10 19:24:49 coworks Exp $
  
  /*
   * @file
   * Select Drupal content to create a newsletter
   */

  /*
   * Node selection page
   * First way to use this module
   */
  function scs_node_selection($form_state) {
  	$form = array();
  	
  	if (is_null($form_state['storage'])) {
  		//First step
  		$form['step'] = array(
  			'#type' => 'hidden',
  			'#value' => 1,
  		);
    	
  		$nodes = _scs_get_nodes();
    	
    	foreach ($nodes as $node) {
    	  $form['nid_' . $node->nid] = array(
    	    '#type' => 'checkbox',
    	  	'#return_value' => $node->nid,
    	  );
    	}
    	
    	$form['newsletter_title'] = array(
    	  '#type' => 'textfield',
    	  '#title' => t('Title'),
    	  '#description' => t('Enter the title of this newsletter'),
    	  '#required' => true,
    	);
    	
    	$form['newsletter_toc'] = array(
    	  '#type' => 'checkbox',
    	  '#title' => t('Create a table of contents'),
    	  '#description' => t('Create a table of contents at top of the newsletter with the titles of the selected nodes. If newsletter is HTML format, these table of contents will be bookmarks.'),
    	);
    	
    	$form['submit'] = array(
    	  '#type' => 'submit',
    	  '#value' => t('Sort nodes'),
    	);
  	} else {
  		$form['step'] = array(
  			'#type' => 'hidden',
  			'#value' => 2,
  		);
  		
  		$form = array_merge($form, scs_sort_nodes($form_state['storage']['nodes']));
  	}
  	
  	return $form;
  }
  
  /*
   * Submit function of the node selection page
   */
  function scs_node_selection_submit($form, &$form_state) {
  	if ($form_state['values']['step'] == 1) {
  		//Standard fields
  		$form_state['storage']['title'] = $form_state['values']['newsletter_title'];
  		$form_state['storage']['toc'] = $form_state['values']['newsletter_toc'];
  		
  		//Selected nodes
    	foreach ($form_state['values'] as $field=>$value) {
    		if (ereg('nid_', $field) && $value != 0) {
    		  $nodes[] = $value;
    		}
    	}
    	
    	$form_state['storage']['nodes'] = $nodes;
  		
  		//Next step
  		$form_state['storage']['step'] = 2;
  		$form_state['rebuild'] == TRUE;
  	} else {
    	foreach($form_state['values'] as $key=>$value) {
          if (ereg('weight_', $key)) {
            $nid = explode('_', $key);
            $nid = $nid[1];
            $nodes[$nid] = $value;
          }
      	}
      	
      	asort($nodes);
    	$nodes = array_keys($nodes);
      	
      	_scs_create_newsletter($form_state['storage']['title'], $nodes, $form_state['storage']['toc']);
  	}
  }
  
  /**
   * Node sort page
   */
  function scs_sort_nodes($nodes = array()) {
  	$fields = false;
    if (array_key_exists('storage', $nodes)) {
      if (count($_GET) != 0) {
      	$fields = true;
      	$nodes = array();
      	foreach ($_GET as $key=>$nid) {
      		if ($key != 'q') {
      			$nodes[] = $nid;
      		}
      	}
      } else {
      	drupal_set_message(t('There was an error. No nodes found'));
      	return array();
      }
    }
    
    $form = array();
    
    if ($fields == TRUE) {
      $form['newsletter_title'] = array(
    	  '#type' => 'textfield',
    	  '#title' => t('Title'),
    	  '#description' => t('Enter the title of this newsletter'),
    	  '#required' => true,
    	);
    	
    	$form['newsletter_toc'] = array(
    	  '#type' => 'checkbox',
    	  '#title' => t('Create a table of contents'),
    	  '#description' => t('Create a table of contents at top of the newsletter with the titles of the selected nodes. If newsletter is HTML format, these table of contents will be bookmarks.'),
    	);
    }
    
    foreach ($nodes as $nid) {
      $form['weight_' . $nid] = array(
        '#type' => 'select',
        '#title' => t('Weight'),
        '#options' => array(0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10),
        '#default_value' => 0, 
      );
    }
    
    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Create newsletter'),
    );
    
    return $form;
  }
  
  /**
   * Submit function of the node sorter page
   */
  function scs_sort_nodes_submit($form, &$form_state) {
    $nodes = array();

    foreach($form_state['values'] as $key=>$value) {
      if (ereg('weight_', $key)) {
        $nid = explode('_', $key);
        $nid = $nid[1];
        $nodes[$nid] = $value;
      }
    }
    
    asort($nodes);
    $nodes = array_keys($nodes);
    
    _scs_create_newsletter($form_state['values']['newsletter_title'], $nodes, $form_state['values']['newsletter_toc']);
  }